#! /usr/bin/env python
# test_classes.py
#
# Copyright (C) 2009, Codethink Ltd.
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
#
# Author:
#       John Carr <john.carr@unrouted.co.uk>

import unittest, pydoc
from tralchemy.ns.rdfs import Class
from tralchemy.ns.nid3 import ID3Audio


class TestClasses(unittest.TestCase):

    def test_make_class(self):
        """ Should be able to get an object representing a class in the ontologies """
        self.failIfEqual(ID3Audio, None)
        self.failUnless('title' in dir(ID3Audio))

    def test_instance_class(self):
        """ Should be able to make an instance of a class from the ontologies """
        obj = Class("nid3:ID3Audio")

    def test_pydoc_classname(self):
        """ pydoc should name the classes appropriately """
        self.failUnlessEqual(pydoc.classname(Class, "tralchemy.rdfs"), "Class")
        self.failUnlessEqual(pydoc.classname(Class, "tralchemy.rdf"), "tralchemy.rdfs.Class")

    def test_help(self):
        """ Make sure classes have docstrings """
        self.failIfEqual(ID3Audio.__doc__, None)


