#! /usr/bin/env python
# vim: set fileencoding=utf-8 :
# test_json_tracker.py
#
# Copyright (C) 2009, Codethink Ltd.
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
#
# Author:
#       John Carr <john.carr@unrouted.co.uk>

import unittest
from tralchemy.json import query, insert


class TestJsonTracker(unittest.TestCase):

    def test_simple(self):
        q = query({
            "name": "class",
            "type": "rdfs:Class",
            })

        model = q.get_model(async=False)
        for row in model:
            pass

    def test_subqueries(self):
        pass

    def test_iterkeys(self):
        q = query({
            "name": "class",
            "type": "rdfs:Class",
            "rdfs:label": "?label",
            })

        model = q.get_model(async=False)
        for row in model:
            pass

        assert "class" in row
        assert row["class"] != ""

        for k, v in row.iteritems():
            pass

    def test_update(self):
        i = insert({
            "type": "nfo:Image",
            "nie:isStoredAs": "Baby’s Arrival.jpg",
            })
        i.execute()
