#! /usr/bin/env python
# test_namespaces.py
#
# Copyright (C) 2009, Codethink Ltd.
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
#
# Author:
#       John Carr <john.carr@unrouted.co.uk>

import unittest
from types import ModuleType

class TestNamespaces(unittest.TestCase):

    def test_import(self):
        """ Should be able to import a module for a namespace """
        from tralchemy.ns import rdf
        self.failUnless(isinstance(rdf, ModuleType))
        import tralchemy.ns.rdfs
        self.failUnless(isinstance(tralchemy.ns.rdfs, ModuleType))

    def test_import_fail(self):
        """ Should get an ImportError if there is no such name space """
        self.failUnlessRaises(ImportError, __import__, "tralchemy.no_such_ontology")
        self.failUnlessRaises(ImportError, __import__, "tralchemy.no.nested.ontologies")


