#! /usr/bin/env python
# test_orm.py
#
# Copyright (C) 2009, John Carr.
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
#
# Author:
#       John Carr <john.carr@unrouted.co.uk>

import unittest, uuid
from tralchemy.ns.rdfs import Resource, Class
from tralchemy.ns.nco import Contact

class TestQueryBuilding(unittest.TestCase):

    def test_nested_resource(self):
        pass

    def test_nested_gets(self):
        """ Find Resource where rdf:type is a Class with a label of 'foo' """
        count = 0
        query = Class.get(subClassOf=Class.get(label="All Resources"))
        for row in query:
            count += 1
        self.assertTrue(count > 0)
        self.assertEquals(count, query.count())

    def test_count(self):
        self.assertTrue(Resource.get().count() > 0)
        pass
