# query.py
#
# Copyright (C) 2009, John Carr.
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
#
# Author:
#       John Carr <john.carr@unrouted.co.uk>

from copy import deepcopy
from .utils import get_classname
from .ast import *
from .json import query

class Query(object):

    def __init__(self, json, cls=None):
        self.json = json
        self.cls = cls

    def count(self):
        q = self.get_json()
        q["select"] = False
        q = query(q)
        count = SelectAs(Function("count", q.get_variable("o")), Variable("win"))
        q.add(count)
        for count in q.get_model(async=False):
            return long(count)

    def get_json(self):
        json = deepcopy(self.json)
        json["name"] = "o"
        return json

    def get_sparql(self):
        return query(self.get_json()).get_sparql()

    def __iter__(self):
        for result in query(self.get_json()).get_model(async=False):
            yield self.cls(get_classname(result))

